
#ifndef _Globals_h
#define _Globals_h

#include <stdio.h>
#include <unistd.h>

#include "handle.h"

void MyError(const char *pcMsg, int nLineno, int nCharPos);

enum ItemType {
        ITEM_TEXT,
        ITEM_WHITESPACE,
        ITEM_TAG_B,
        ITEM_TAG_EM,
        ITEM_TAG_I,
        ITEM_TAG_PL,
        ITEM_TAG_S,
        ITEM_TAG_TT,
        ITEM_TAG_U,
        ITEM_TAG_0,
        ITEM_TAG_1,
        ITEM_TAG_2,
        ITEM_TAG_3,
        ITEM_TAG_4,
        ITEM_TAG_5,
        ITEM_TAG_6,
        ITEM_TAG_7,
        ITEM_TAG_8,
        ITEM_TAG_9,
        ITEM_TAG_r,
        ITEM_TAG_g,
        ITEM_TAG_b,
        ITEM_TAG_c,
        ITEM_TAG_m,
        ITEM_TAG_y,
        ITEM_TAG_k,
        ITEM_TAG_w,
        ITEM_NUM_ENUMS
};

extern const ItemType FIRST_TAG_ITEM;

class DocItem;
typedef HANDLE<DocItem> DocItemHandle;

#endif //_Globals_h
