
#ifndef _Optimize_h
#define _Optimize_h

#include "Document.h"

typedef bool (OptimizeFunc) (Document *pDocument);

// in-place optimizations
bool CompressWhitespace (Document *pDocument);
bool EliminateRedundancies (Document *pDocument);
bool EmptyTags (Document *pDocument);
bool CombineText (Document *pDocument);
bool RearrangeWhitespace (Document *pDocument);
bool EmptyReverseTags (Document *pDocument);
bool CompressEM (Document *pDocument);
bool NestColors (Document *pDocument);


bool FindColorChain (ListNode item, ListNode iEnd, ListNodeList &result);

#endif //_Optimize_h
