
#ifndef _BuildDoc_h
#define _BuildDoc_h

#include <stdio.h>

#include "Globals.h"
#include "Item.h"
#include "Context.h"
#include "Document.h"
#include "Parser.h"

void HandleText (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart);
void HandleWhitespace (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart);
void HandleUnknownTag (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart);
void HandleTag (void *pArg, const char *pcSource, int nSize, int nLineno, bool bStart);
ListNode AddItem (Document *pDocument, DocItemHandle newItem);
void BuildDoc(Document *pDocument, const char *pSource, int nSize);

#endif //_BuildDoc_h
